;;;---------------------------------------------------------------------------;
;;; FILENAME: btext.lsp
;;;
;;;   Copyright (C) 2000 by Atkinson Automation
;;;  
;;;   Permission to use, copy, modify, and distribute this software and its
;;;   documentation for any purpose and without fee is hereby granted.  
;;;
;;;   THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY. 
;;;   ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF 
;;;   MERCHANTABILITY ARE HEREBY DISCLAIMED.
;;;
;;;   By: J Atkinson / Ralph Pullinger - Atkinson Automation UK
;;;
;;;   Date: 4/10/99
;;;
;;;---------------------------------------------------------------------------;
;;; MODIFICATION HISTORY
;;;	V1.0 Initial release for R14
;;;
;;;---------------------------------------------------------------------------;


(defun dtor (arg)
	(* pi (/ arg 180.0))
)

(defun rtod (arg)
	(* 180.0 (/ arg pi))
)



(defun c:btext (/ lp1 lp2 llx lly urx ury en ss texten textent en ed tb ul ll ur #osmode lr la txtht)
	(prompt "\nSelect text to box: ")
	(setq ss (ssget (list (cons -4 "<OR") (cons 0 "TEXT") (cons 0 "MTEXT") (cons -4 "OR>"))))
	(if (= (sslength ss) 1)
		(progn
			(setq en (ssname ss 0))
			(setq ed (entget en))
			(if (= (cdr (assoc 0 ed)) "TEXT")
				(progn
					(command ".UCS" "OB" en)
					(setq tb (textbox (list (cons -1 en)))
						ll (car tb)
						ur (cadr tb)
						ul (list (car ll) (cadr ur))
						lr (list (car ur) (cadr ll))
					)
				)
				(progn
					(setq ip (cdr (assoc 10 ed)) ap (cdr (assoc 71 ed)))
					(setq w (cdr (assoc 42 ed)) h (cdr (assoc 43 ed)) a (cdr (assoc 50 ed)))
					(cond
						((= ap 1)
							(setq ul ip)
							(setq ll (polar ul (- a (/ pi 2.0)) h))
							(setq ur (polar ul a w))
							(setq lr (polar ll a w))
						)
						((= ap 2)
							(setq ul (polar ip (- a pi) (/ w 2.0)))
							(setq ll (polar ul (- a (/ pi 2)) h))
							(setq ur (polar ul a w))
							(setq lr (polar ll a w))
						)
						((= ap 3)
							(setq ur ip)
							(setq ul (polar ur (- a pi) w))
							(setq ll (polar ul (- a (/ pi 2.0)) h))
							(setq lr (polar ll a w))
						)
						((= ap 4)
							(setq ll (polar ip (- a (/ pi 2.0)) (/ h 2.0)))
							(setq ul (polar ll (+ a (/ pi 2.0)) h))
							(setq lr (polar ll a w))
							(setq ur (polar ul a w))
						)
						((= ap 5)
							(setq ip (polar ip (- a pi) (/ w 2.0)))
							(setq ll (polar ip (- a (/ pi 2)) (/ h 2.0)))
							(setq ul (polar ll (+ a (/ pi 2.0)) h))
							(setq lr (polar ll a w))
							(setq ur (polar ul a w))
						)
						((= ap 6)
							(setq ur (polar ip (+ a (/ pi 2.0)) (/ h 2.0)))
							(setq lr (polar ur (- a (/ pi 2.0)) h))
							(setq ul (polar ur (- a pi) w))
							(setq ll (polar lr (- a pi) w))
						)
						((= ap 7)
							(setq ll ip)
							(setq ul (polar ll (+ a (/ pi 2.0)) h))
							(setq lr (polar ll a w))
							(setq ur (polar ul a w))
						)
						((= ap 8)
							(setq ll (polar ip (- a pi) (/ w 2.0)))
							(setq ul (polar ll (+ a (/ pi 2.0)) h))
							(setq lr (polar ll a w))
							(setq ur (polar ul a w))
						)
						((= ap 9)
							(setq lr ip)
							(setq ur (polar lr (+ a (/ pi 2.0)) h))
							(setq ll (polar lr (- a pi) w))
							(setq ul (polar ur (- a pi) w))
						)
					)
				)
			)
			(command ".PLINE" ll lr ur ul "C")
			(setq txtht (cdr (assoc 40 ed)))
			(setq en (entlast))
			(setq en (list en ul))
			(command ".OFFSET" (/ txtht 2.0) en (polar ul (+ (angle ul ur) (/ pi 2.0)) txtht) "")
			(entdel (car en))
			(command ".UCS" "")
		)
		(progn
			(setq count 0)
			(setq ssn (ssadd))
			(prompt "\nFiltering for single line text...")
				(repeat (sslength ss)
						(setq en (ssname ss count))
						(setq ed (entget en))
						(if (= (cdr (assoc 0 ed)) "TEXT")
							(setq ssn (ssadd en ssn))
						)
						(setq count (1+ count))
				)
			(prompt "done.")
				(setq count 0)
				(setq llx '() lly '() urx '() ury '())
				(command ".ROTATE" ssn "" '(0 0) (- (rtod (setq ra (cdr (assoc 50 ed))))))
					(repeat (sslength ssn)
					(setq en (ssname ssn count))
					(setq ed (entget en))
					(command ".UCS" "OB" en)
					(setq tb (textbox (list (cons -1 en)))
							ll (trans (car tb) 1 0)
							ur (trans (cadr tb) 1 0)
					)
						(setq dist1 (distance ll ur))
						(if (= count 0)(setq llx nil))
						(if (or (= llx nil)(< (car ll) llx))(setq llx (car ll))(setq llx llx))
						(if (= count 0)(setq lly nil))
						(if (or (= lly nil)(< (cadr ll) lly))(setq lly (cadr ll))(setq lly lly))
						(if (= count 0)(setq urx nil))
						(if (or (= urx nil)(> (car ur) urx))(setq urx (car ur))(setq urx urx))
						(if (= count 0)(setq ury nil))
						(if (or (= ury nil)(> (cadr ur) ury))(setq ury (cadr ur))(setq ury ury))
						(setq count (1+ count))
						(command ".UCS" "")
				)
					(setq ll (list llx lly) ur (list urx ury) ul (list llx ury) lr (list urx lly)) 
					(command ".PLINE" ll lr ur ul "C")
					(setq txtht (cdr (assoc 40 ed)))
					(setq en (entlast))
					(setq en (list en ul))
					(command ".OFFSET" (/ txtht 2.0) en (polar ul (+ (angle ul ur) (/ pi 2.0)) txtht) "")
					(entdel (car en))
					(command ".ROTATE" ssn (entlast) "" '(0 0) (rtod ra))
		)
	)
(setq #osmode (getvar "OSMODE"))
(setvar "OSMODE" 32)
(setq lp2 (getpoint "Select corner of box for leader to end: "))
(setq lp1 (getpoint "Select start point for leader: "))
(setvar "OSMODE" #osmode)
(command "._qleader" lp1 lp2 "")
)